#include <unistd.h>
#include <csignal>
#include <cstdlib>
#include <iostream>

void handler(int s){
    std::cerr<< "The test harness timed out. Signal = "
	     << s << std::endl;
    exit(1);
}

int main(int argc, char * argv[]) {
    if(argc != 3){
	std::cerr << argv[0] << " <time limit> <test harness>" << std::endl;
	exit(1);
    }

    unsigned t = atoi(argv[1]);

    if(getenv("SAS_TEST_TIMEOUT")){
	t = atoi(getenv("SAS_TEST_TIMEOUT"));
	std::cerr << "Message: test harness timeout set from environment."
		  << std::endl;
    }

    std::cerr << "Message: " << "will run " << argv[2]
	      << " for no longer than " << t << " seconds." << std::endl;

    signal(SIGALRM, handler);
    alarm(t);
    if(system(argv[2])){
 	std::cerr << "Error while running " << argv[2] << std::endl;
 	exit(1);
     }
}
